#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityMayDayMissionCFG.h"
std::auto_ptr<M_ActivityMayDayMissionCFG> M_ActivityMayDayMissionCFG::msSingleton(nullptr);

int M_ActivityMayDayMissionCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityMayDayMissionCFGData* M_ActivityMayDayMissionCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityMayDayMissionCFGData>& M_ActivityMayDayMissionCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityMayDayMissionCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityMayDayMissionCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityMayDayMissionCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mCompleteType = element->IntAttribute("CompleteType");
		data.mCompleteParam = element->IntAttribute("CompleteParam");
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		{
			const char* RewardItem = element->Attribute("RewardItem");
			std::vector<std::string> vecRewardItem;
			boost::split(vecRewardItem, RewardItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardItem[i].c_str(), &temp))
				{
					data.mRewardItem.push_back(temp);
				}
			}
		}
		{
			const char* RewardQuantity = element->Attribute("RewardQuantity");
			std::vector<std::string> vecRewardQuantity;
			boost::split(vecRewardQuantity, RewardQuantity, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardQuantity.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardQuantity[i].c_str(), &temp))
				{
					data.mRewardQuantity.push_back(temp);
				}
			}
		}
		data.mGoType = element->IntAttribute("GoType");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityMayDayMissionCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityMayDayMissionCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityMayDayMissionCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityMayDayMissionCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityMayDayMissionCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "CompleteType", data.mCompleteType);
		LuaCfgHelper::readInt(L, "CompleteParam", data.mCompleteParam);
		LuaCfgHelper::readInt(L, "CompleteCount", data.mCompleteCount);
		LuaCfgHelper::readVectorInt(L, "RewardItem", data.mRewardItem);
		LuaCfgHelper::readVectorInt(L, "RewardQuantity", data.mRewardQuantity);
		LuaCfgHelper::readInt(L, "GoType", data.mGoType);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityMayDayMissionCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityMayDayMissionCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityMayDayMissionCFG* M_ActivityMayDayMissionCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityMayDayMissionCFG());
	}
	return msSingleton.get();
}

void M_ActivityMayDayMissionCFG::Release()
{
	msSingleton.reset(nullptr);
}
